/********************************** (C) COPYRIGHT *********************************
* File Name          : CH395.H
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395.Cݽṹ
*                      
**********************************************************************************/

#ifndef __CH395_H__
#define __CH395_H__

/* TCPģʽ0Ϊͻˣ1Ϊ */
#define TCP_CLIENT_MODE                                      0
#define TCP_SERVER_MODE                                      1

struct _CH395_SYS
{
    UINT8   IPAddr[4];                                           /* CH395IPַ 32bit*/
    UINT8   GWIPAddr[4];                                         /* CH395صַ 32bit*/
    UINT8   MASKAddr[4];                                         /* CH395 32bit*/
    UINT8   MacAddr[6];                                          /* CH395MACַ 48bit*/
    UINT8   PHYStat;                                             /* CH395 PHY״̬ 8bit*/
    UINT8   MackFilt;                                            /* CH395 MACˣĬΪչ㲥ձMAC 8bit*/
    UINT32  RetranCount;                                         /* Դ ĬΪ10*/
    UINT32  RetranPeriod;                                        /* ,λMS,Ĭ200MS */
    UINT8   IntfMode;                                            /* ӿģʽ */
    UINT8   UnreachIPAddr[4];                                    /* ɵIP */
    UINT16  UnreachPort;                                         /* ɵ˿ */
};

struct _SOCK_INF
{
    UINT8  IPAddr[4];                                           /* socketĿIPַ 32bit*/
    UINT8  MacAddr[6];                                          /* socketĿַ 48bit*/
    UINT8  ProtoType;                                           /* Э */
    UINT8  ScokStatus;                                          /* socket״̬οscoket״̬ */
    UINT8  TcpMode;                                             /* TCPģʽ */
    UINT32 IPRAWProtoType;                                      /* IPRAW Э */
    UINT16 DesPort;                                             /* ĿĶ˿ */
    UINT16 SourPort;                                            /* ĿĶ˿ */
    UINT16 SendLen;                                             /* ݳ */
    UINT16 RemLen;                                              /* ʣ೤ */
    UINT8  *pSend;                                              /* ָ */                                               
};  


/*private*/

extern  UINT8 CH395IPAddr[4];                       /* CH395IPַ */
extern UINT8 CH395GWIPAddr[4];                      /* CH395 */
extern UINT8 CH395IPMask[4];                        /* CH395 */

void DelaymS(UINT8 ms);
void mStopIfError(UINT8 iError);
void InitCH395InfParam(void);
void InitSocketParam(void);
void CH395SocketInitOpen(void);
void CH395SocketInterrupt(UINT8 sockindex);
void CH395GlobalInterrupt(void);
UINT8  CH395Init(void);

#endif

/************************** endfile **************************************/
