/********************************** (C) COPYRIGHT *********************************
* File Name          : MAIN.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395WEBʾ
**********************************************************************************/

/*********************************************************************************
CH395 TCP/IP Эӿ
CH563 ʾʾCH395WEB
1ͨWEBSEVERҳɷĽLEDƣʱʾLED״̬
2ͨĬIP192.168.111.64Ĭ϶˿80WebServerڿҳIPPortãchangeť
   µIPͶ˿ڣͨµIPPortWebServer
3ڼⴰڣͨwatchťʵʱ鿴Ϣ
**********************************************************************************/

/* ͷļ*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\SRC\CH563SFR.H"
#include "..\SRC\SYSFREQ.H"
#include "..\..\PUB\CH395INC.H"
#include "CH395.H"
#include "HTTPS.H"

/**********************************************************************************/
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽ
4: ģSPIʽ
5: Ӳ첽ӷʽ
*/
#define   CH395_OP_INTERFACE_MODE             3                    
#if   (CH395_OP_INTERFACE_MODE == 1)                                                  /* SEL = 0, TX = 1*/
#include "CH395PARA_HW.C"                                           
#elif (CH395_OP_INTERFACE_MODE == 2)                                                  /* SEL = 0, TX = 1*/
#include "CH395PARA_SW.C"                                                             /*ģⲢڣ޽ӿڳ*/
#elif (CH395_OP_INTERFACE_MODE == 3)                                                  /* SEL = 1, TX = 0*/
#include "CH395SPI_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 4)                                                  /* SEL = 1, TX = 0*/
#include "CH395SPI_SW.C"                                                              /*ģspi޽ӿڳ*/
#elif (CH395_OP_INTERFACE_MODE == 5)                                                  /* SEL = 1, TX = 1*/
#include "CH395UART.C"
#else
#error "Please Select Correct Communication Interface "
#endif

/***********************************************************************************/
/* ļ */
#include "..\..\PUB\CH395CMD.C"

/* ñ */
 st_http_request *http_request;  
 UINT8  flag;		   		  									                                              /*CH395³ʼ־*/
 UINT8  RecvBuffer[4096];               

/* CH395ض */
 UINT8 CH395MACAddr[6] = {0x02,0x03,0x04,0x05,0x06,0x07};                                /* CH395MACַ */
 UINT8 CH395IPAddr[4] = {192,168,1,10};                                                /* CH395IPַ */
 UINT8 CH395GWIPAddr[4] = {192,168,10,1};                                               /* CH395 */
 UINT8 CH395IPMask[4] = {255,255,255,0};                                                 /* CH395 */

/* socket ض*/
/* socket ض*/
 UINT16 Socket0SourPort = 80;                                                            /* Socket 0Դ˿ */

__irq void FIQ_Handler( void )
{
    while(1);
}
__irq void IRQ_Handler( void )
{
    while(1);
}

/**********************************************************************************
* Function Name  : mInitSTDIO
* Description    : ڳʼ,ʹ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void  mInitSTDIO(void)
{
  UINT32  x, x2;

  /*0ʼڴӡϢ*/
  x = 10 * FREQ_SYS * 2 / 16 /115200;                                                   /* ڲΪ115200bps*/
  x2 = x % 10;
  x /= 10;
  if ( x2 >= 5 ) x ++;                                                                   /*  */
  R8_UART0_LCR = 0x80;                                                                   /* DLABλ1   */
  R8_UART0_DIV = 1;                                                                      /* ԤƵ   */
  R8_UART0_DLM = x>>8;
  R8_UART0_DLL = x&0xff;
  R8_UART0_LCR = RB_LCR_WORD_SZ ;                                                         /*ֽڳΪ8 */
  R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |  RB_FCR_FIFO_EN ;/*FIFOΪ28巢ͺͽFIFOFIFOʹ  */
  R8_UART0_IER = RB_IER_TXD_EN | RB_IER_LINE_STAT |RB_IER_THR_EMPTY | RB_IER_RECV_RDY  ;  /* TXD enable */
  R8_UART0_MCR = RB_MCR_OUT2;                                                             /*жʹ */
  R8_INT_EN_IRQ_0 |= RB_IE_IRQ_UART0;  
  R32_PB_SMT |= RXD0|TXD0;                                                                /* RXD0 schmitt input, TXD1 slow rate     */
  R32_PB_PD &= ~ RXD0;                                                                    /* disable pulldown for RXD1, keep pullup */
  R32_PB_DIR |= TXD0;                                                                     /* TXD1 output enable */

  /*1ʼCH395ͨ*/
  x = 10 * FREQ_SYS * 2 / 16 /9600;                                                       /* 9600bps */
  x2 = x % 10;
  x /= 10;
  if ( x2 >= 5 ) x ++; 
  R8_UART1_LCR = 0x80;  
  R8_UART1_DIV = 1;  
  R8_UART1_DLM = x>>8;
  R8_UART1_DLL = x&0xff;
  R8_UART1_LCR = RB_LCR_WORD_SZ ;
  R8_UART1_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |  RB_FCR_FIFO_EN ;
  R8_UART1_IER = RB_IER_TXD_EN | RB_IER_LINE_STAT |RB_IER_THR_EMPTY | RB_IER_RECV_RDY  ;  
  R8_UART1_MCR = RB_MCR_OUT2; 
  R8_INT_EN_IRQ_0 |= RB_IE_IRQ_UART1;  
  R32_PB_SMT |= RXD1|TXD1;  
  R32_PB_PD &= ~ RXD1; 
  R32_PB_DIR |= TXD1;  
}

int  fputc( int c, FILE *f )
{
  R8_UART0_THR = c;                          
  while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );      
  return( c );
}

/**********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
int main(void)
{
   UINT16 i;
   R32_PA_DIR = 0xffffffff;                                                            /*PA*/
   R32_PA_PU  = 0xffffffff;
   R32_PA_DIR |= (TACK|TDI);                                                           /*GPIOʼLEDƿ*/
   R32_PA_PU  |= (TACK|TDI);
   R32_PA_OUT |= (TACK|TDI);
   mDelaymS(100);
   mInitSTDIO();
   http_request = (st_http_request*)RecvBuffer;
   printf("CH395EVT Test Demo\n");
   CH395_PROT_INIT();
 restart:                                                                               /* ʱ100 */ 
   InitCH395InfParam();                                                                /* ʼCH395ر */
   i = CH395Init();                                                                    /* ʼCH395оƬ */
   mStopIfError(i);
   while(1)
   {                                                                                   /* ȴ̫ӳɹ*/
       if(CH395CMDGetPHYStatus() == PHY_DISCONN)                                       /* ѯCH395Ƿ */
       {
           mDelaymS(200);                                                              /* δȴ200MSٴβѯ */
       }
       else 
       {
           printf("CH395 Connect Ethernet\n");                                         /* CH395оƬӵ̫ʱж */
           break;
       }
   }
   InitSocketParam();                                                                  /* ʼsocketر */
   CH395SocketInitOpen();
   while(1)
   {
     if(Query395Interrupt())CH395GlobalInterrupt();                                    /*ѯж*/
     WebServer();
     if((flag & IPCHANGE )|( flag & PORTCHANGE) )                                      /*IPPortıλCH395³ʼ*/
     {
       flag  &=~(IPCHANGE|PORTCHANGE) ;
       printf("reset all!\n");
       CH395CMDReset();
       for(i=0;i<15;i++) { mDelaymS(200);}                                             /*Լʱ3S*/
       printf("restart\n");
       goto restart;
     }
   }
}

