/********************************** (C) COPYRIGHT *******************************
* File Name          : CH395PARA_SW.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395оƬ ģⲢӵӲ V1.0
*                    
*******************************************************************************/

/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ    CH395оƬ
      P2.0                 A0
      P2.6                 CS#    ģĲֻCH395,ôCS#ֱӽӵ͵ƽ,ǿƬѡ
      P3.6                 WR#
      P3.7                 RD#
      P0(8λ˿)         D7-D0 */	/*51ƬעP0Ҫ*/

sbit    CH395_A0        =          P2^0;
sbit    CH395_CS        =          P2^6;
sbit    CH395_WR        =          P3^6;
sbit    CH395_RD        =          P3^7;
#define CH395_DATA_DAT_OUT( d )    { P0 = d; }                   /* 򲢿 */
#define CH395_DATA_DAT_IN( )       ( P0 )                        /* Ӳ */
#define CH395_DATA_DIR_OUT( )                                    /* òڷΪ */
#define CH395_DATA_DIR_IN( )       { P0 = 0xFF; }                /* òڷΪ */

#define CH395_INT_WIRE             INT1                          /* ٶCH395INT#,δôҲͨѯ״̬˿ʵ */

/*******************************************************************************
* Function Name  : mDelayuS
* Description    : ʱָ΢ʱ,ݵƬƵ,ȷ
* Input          : us---ʱʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mDelayuS( UINT8 us )
{
    while( us -- );                                              /* MCS51@24MHz */
}

/*******************************************************************************
* Function Name  : mDelaymS
* Description    : ʱָʱ,ݵƬƵ,ȷ
* Input          : ms---ʱʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mDelaymS( UINT8 ms )
{
    while( ms -- ) 
    {
        mDelayuS( 250 );
        mDelayuS( 250 );
        mDelayuS( 250 );
        mDelayuS( 250 );
    }
}

/********************************************************************************
* Function Name  : CH395_PORT_INIT
* Description    : Ӳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_PORT_INIT(void)
{
    CH395_WR = 1;                                                    /* WRĬΪ */
    CH395_RD = 1;                                                    /* RDĬΪ */
    CH395_A0 = 0;                                                    /* A0ĬΪ */
    CH395_CS = 1;                                                    /* CSĬΪ */
    CH395_DATA_DIR_IN();                                             /* ˿Ϊ */
}

/********************************************************************************
* Function Name  : xWriteCH395Cmd
* Description    : CH395д
* Input          : cmd 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH395Cmd(UINT8 cmd)                                       /* CH395д */
{
    CH395_DATA_DAT_OUT(cmd);                                         /* 8λдݶ˿ */
    CH395_DATA_DIR_OUT();                                            /*  */
    CH395_A0 = 1;                                                    /* A0Ϊ */
    CH395_WR = 0;                                                    /* WR */
    CH395_CS = 0;                                                    /* CS */
    CH395_CS = 0;                                                    /* Чʱʹ */
    CH395_CS = 0;                                                    /* Чʱʹ */
    CH395_WR = 1;                                                    /* WRΪ */
    CH395_CS = 1;                                                    /* CSΪ */
    CH395_A0 = 0;                                                    /* A0 */
    CH395_DATA_DIR_IN();                                             /* ݶ˿Ϊ */
    mDelayuS(2);                                                     /* Ҫʱ,ʱ1.5uSȷдڲС1.5uS */
}

/********************************************************************************
* Function Name  : xWriteCH395Data
* Description    : CH395д8λ
* Input          : mdata 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void  xWriteCH395Data(UINT8 mdata)
{                                                                    /* CH395д */
    CH395_DATA_DAT_OUT(mdata);                                       /* 8λдݶ˿ */
    CH395_DATA_DIR_OUT();                                            /*  */
    CH395_WR = 0;                                                    /* WR */
    CH395_CS = 0;                                                    /* CS */
    CH395_CS = 0;                                                    /* Чʱʹ,뱣֤дȴ40ns */
    CH395_WR = 1;                                                    /* WRΪ */
    CH395_CS = 1;                                                    /* CSΪ */
    CH395_DATA_DIR_IN();                                             /* ݶ˿Ϊ */
   // mDelayuS(1);                                                   /* ȷдڴ0.6uS */
}

/********************************************************************************
* Function Name  : CH395_PORT_INIT
* Description    : Ӳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8   xReadCH395Data( void )                                       /* CH395 */
{
    UINT8 i;
    
    CH395_DATA_DIR_IN();                                             /* ݶ˿Ϊ */
    CH395_RD = 0;                                                    /* RD */
    CH395_CS = 0;                                                    /* CS */
    CH395_CS = 0;                                                    /* Чʱʹ */
    CH395_CS = 0;                                                    /* Чʱʹ,뱣֤дȴ40ns */
    i = CH395_DATA_DAT_IN();                                         /* Ӷ˿ڶ */
    CH395_RD = 1;                                                    /* RDΪ */
    CH395_CS = 1;                                                    /* CSΪ */
    CH395_DATA_DIR_IN();                                             /* ݶ˿Ϊ */
    return i;
}
#define xEndCH395Cmd()     {}                                        /* SPIģʽЧ */

/**************************** endfile *************************************/
